#ifndef FILTERSETTINGS_H
#define FILTERSETTINGS_H

#define FILTER_TYPE    IMAGEFILTER_PIXELWISE   // CHOICES: IMAGEFILTER_PIXELWISE, IMAGEFILTER_BOX, IMAGEFILTER_BLOCK, IMAGEFILTER_RECURSIVE
#define FILTER_GROUP   "Morfolgiai (binris) szrk"
#define FILTER_NAME    "Vkonyts (Thinning, border, skeleton)"
#define FILTER_VERSION VER_GEN(1,0,0,0)

struct filtersettings {
	// DO NOT MODIFY
	int   width;
	int   height;
	int   stridein;
	int   strideout;
	int   channelcountin;
	int   channelcountout;
	int   pixelsizein;
	int   pixelsizeout;
	byte* mask;
	byte* datain;
	byte* dataout;
	int*  processing_ptr;
	int*  processing_size;
	int   nCoreEnabled;
	int*  nCoreKillSignal;
	int   nCoreExecutionSize;  // BOX: radius, PIXELWISE: 1, BLOCK: blocksize
	int   nCoreThreadId;
	int   nCoreProcessedPixelsTemp;
	int   error;

	// Extension
	int   filtering_iterations_limit; // 0 = Inf (Skeleton), X>0 = Thinning
	int*  eliminated_pixels;

	// Shared speedup arrays
	unsigned char zero_to_non_zero_transitions[256]; // USED ON ROW-WISE NEIGHBOURS
	unsigned char count_of_non_zero_neighbours[256];
	unsigned char P2_P4_P6_multiply_is_zero[256];
	unsigned char P2_P4_P8_multiply_is_zero[256];
	unsigned char rowwise_to_ccw_neigbours[256]; 
};

#endif
